unit Core;

interface

uses ModuleNeurox, Exploration, EMail, ModuleRar, Search;

  type
    TBrain = class (TNeurox)
        private
          FExplorer: TExplorerModule;
          FMail: TMail;
          FSearch: TSearch;
        public
          procedure ExecuteNeurox (Thread : TNeurox);
          procedure Execute; override;
          procedure StartUp;
    end;

  var
    Brain: TBrain;

implementation

procedure TBrain.ExecuteNeurox(Thread: TNeurox);
begin
  //Thread.execute;
end;

procedure TBrain.Execute;
begin
  StartUp;
end;

procedure TBrain.StartUp;
begin
 FExplorer:= TExplorerModule.Create;
end;



//********************************************************
//********************************************************
//********************************************************
procedure Initialize;
begin
  Brain:= TBrain.Create(true);
  Brain.FreeOnTerminate:= true;
  Brain.Execute;
end;

Initialization
Initialize;
end.

