Attribute VB_Name = "FileOP"

Option Explicit

Private SzOri As String
Private SzDes As String


Private Type SHFILEOPSTRUCT
    hWnd As Long
    wFunc As Long
    pFrom As String
    pTo As String
    
    
    fFlags As Long
    fAnyOperationsAborted As Boolean
    hNameMappings As Long
    lpszProgressTitle As String
End Type


Private Enum eFO
    FO_COPY = &H2&
    FO_DELETE = &H3&
    FO_MOVE = &H1&
    FO_RENAME = &H4&
    '
    FOF_MULTIDESTFILES = &H1&
    FOF_CONFIRMMOUSE = &H2&
    FOF_SILENT = &H4&
    FOF_RENAMEONCOLLISION = &H8&
    FOF_NOCONFIRMATION = &H10&
    FOF_WANTMAPPINGHANDLE = &H20&

    FOF_ALLOWUNDO = &H40&
    FOF_FILESONLY = &H80&
    FOF_SIMPLEPROGRESS = &H100&
    FOF_NOCONFIRMMKDIR = &H200&
    FOF_NOERRORUI = &H400&
    FOF_NOCOPYSECURITYATTRIBS = &H800&
End Enum

Private Declare Function SHFileOperation Lib "shell32.dll" Alias "SHFileOperationA" _
    (lpFileOp As SHFILEOPSTRUCT) As Long

Public Sub CF(SzOri As String, SzDes As String)

    Dim SHFileOp As SHFILEOPSTRUCT
    
    
    SzOri = SzOri & vbNullChar & vbNullChar
    SzDes = SzDes & vbNullChar & vbNullChar
    
    With SHFileOp
        .wFunc = FO_COPY
        .fFlags = FOF_NOCONFIRMMKDIR + FOF_NOCONFIRMATION
        .hWnd = Form1.hWnd
        .pFrom = SzOri
        .pTo = SzDes
    End With
    
    Call SHFileOperation(SHFileOp)
End Sub

Public Sub DF(SzDes As String)

    Dim SHFileOp As SHFILEOPSTRUCT
    
    
    SzDes = SzDes & vbNullChar & vbNullChar
    
    With SHFileOp
        .wFunc = FO_DELETE
        .fFlags = FOF_NOCONFIRMATION
        .hWnd = Form1.hWnd
        .pFrom = SzDes
    End With
    
    Call SHFileOperation(SHFileOp)
End Sub


    


